define(["controllers/UserConfigurationController", "properties/App.Settings"], function (UserConfigurationController, Settings) {
            function ZeroTouchConfigurationController() {
                var self = this;

                self.configure = function (configurationJsonData) {
                    var dfd = $.Deferred();

                    try {
                        // Currently do not save this for any webOS before 4.1
                        if (configurationJsonData.settings && Settings.application.webOSVersion >= 4.1) {
                            var usePMModeSettingsUpdated = false;

                            // Check pm mode and update if different
                            if (configurationJsonData.settings.usePMModeForScreenManagement !== UserConfigurationController.usePMModeForScreenManagement()) {
                                logger.debug("Updated PM Mode: " + configurationJsonData.settings.usePMModeForScreenManagement);
                                usePMModeSettingsUpdated = true;
                                var updatedPMMode = configurationJsonData.settings.usePMModeForScreenManagement;
                                UserConfigurationController.usePMModeForScreenManagement(updatedPMMode);
                            }

                            if (usePMModeSettingsUpdated) {
                                // Save the updated settings
                                UserConfigurationController.saveSettings();
                            }

                            dfd.resolve(false); //LG wont require a reboot
                        } else {
                            // There are no settings to apply, so resolve anyway
                            logger.warning("There are no configuration settings to apply..");
                            dfd.resolve(false);
                        }
                    } catch (e) {
                        logger.error(e);
                    }
                    return dfd;
                };
            };

            return new ZeroTouchConfigurationController();
        });