Array.prototype.find||(Array.prototype.find=function(r){if(null==this)throw new TypeError('"this" is null or not defined');var t=Object(this),n=t.length>>>0;if("function"!=typeof r)throw new TypeError("callback must be a function");for(var o=arguments[1],e=0;e<n;){var i=t[e];if(r.call(o,i,e,t))return i;e++}});

define(["properties/App.Settings", "system/io/File", "system/io/DirectoryInfo", "system/plugins/DownloadPlugin", "gui/PlayUrlHelper", "controllers/WidgetEventController", "models/TokenModel", "models/TokenClaims", "models/API", "core/SLAPIMethodsInterface", "system/DateTime"], function(Settings, File, DirectoryInfo, Downloader, PlayUrlHelper, WidgetEventController, TokenModel, TokenClaims, API, SLAPIMethodsInterface, DateTime) {
	function DSSAPIInterface() {
		var self = this;
		self.dssConfig = {};
		self.integrations = [];
		self.syncInProgress = false;
		self.syncTimer = null;
		self.integrationSyncTimers = {};
		self.dssSchema = null;

		var apiInterface = new SLAPIMethodsInterface();

		var REMOTE_FILE_TYPE_NAME = Settings.application.dataSyncServices.remoteFileTypeName;
		var SCHEMA_QUERY = Settings.application.dataSyncServices.schemaQuery;
		var DATA_FILE_NAME = Settings.application.dataSyncServices.dataFileName;
		var UNMODIFIED_DATA_FILE_NAME = Settings.application.dataSyncServices.unmodifiedDataFileName;
		var REMOTE_FILES_SUB_DIR_NAME = Settings.application.dataSyncServices.remoteFileSubDirectoryName;
		
		self.synchroniseIntegrationsForMediaAssets = function(dssConfig, integrations, mediaAssets, resync) {
			var syncDFD = $.Deferred();
			logger.info('synchroniseIntegrationsForMediaAssets() - Resync: ' + resync);
			// Clear Timeout
			clearTimeout(self.syncTimer);
			self.syncTimer = null;
			// Do not recheck schema if this is a resync
			var skipSchemaUpdate = resync;
			// Only need to update the configuration and reset sync timers if this is not a resync (a config update has occurred or first run after startup)
			if (!resync) {
				// Update config and integrations list
				logger.info('Updating stored dss configuration');
				self.dssConfig = dssConfig;
				self.integrations = integrations;
				self.integrationSyncTimers = {};
				if (self.syncInProgress == true) {
					logger.info('Sync in progress....');
					self.syncTimer = setTimeout(function() {
						self.synchroniseIntegrationsForMediaAssets(dssConfig, integrations, mediaAssets);
					}, 5 * 1000);
					return syncDFD.reject();
				}
			}
			self.syncInProgress = true;
			updateDSSSchema(skipSchemaUpdate)
				.then(function() {
					// We can't continue if we do not have a schema at this point
					if (self.dssSchema == null) {
						logger.error('Unable to load dss schema. Can not continue to sync integrations');
						self.syncInProgress = false;
						return syncDFD.reject();
					}
					// Start sync for each integration sequentially
					var allIntegrationsSynced = $.Deferred().resolve();
					// logger.info('Number of integrations to sync: ' + integrations.length);
					$.each(integrations, function(index, integration) {
						logger.info('Checking Integration: ' + integration.objectId);
						// Get all media Assets that reqiore data from this integration.
						// We need to know these so we can write the data to a the directory for each widget.
						// We do this so we can make the data/files more easily available to each widget
						var mediaAssetsThatUseIntegrationData = mediaAssets.filter(function(mediaAsset) {
							return mediaAsset.integrations.some(function(maIntegration) {
								return maIntegration.integrationId === integration.integrationId && maIntegration.objectId === integration.objectId;
							});
						});
						logger.info('Number of media assets using integration: ' + mediaAssetsThatUseIntegrationData.length);
						// Only resync if the integration does not have a sync timer (new) or the sync timer has expired (<= current time)
						var integrationSyncTimer = self.integrationSyncTimers[integration.objectId];
						if (integrationSyncTimer == null || integrationSyncTimer.getTime() <= new Date().getTime()) {
							allIntegrationsSynced = allIntegrationsSynced.then(function() {
								return syncIntegrationForMediaAssets(integration, mediaAssetsThatUseIntegrationData);
							});
						}
						else {
							logger.info('Integration is not scheduled to be resynced at this time.');
						}						
					});
					// When all integrations have synced
					allIntegrationsSynced
						.done(function() {
							logger.info('All integrations have been sucessfully synced');
							syncDFD.resolve();
						})
						.fail(function(err) {
							logger.error('Error sycning integrations: ' + err);
							syncDFD.reject();
						})
						.always(function() {
							// DSS main sync process runs every minute but only syncs each integration as per their schedules
							// This should only ever not be null if we have run into a case where a sync is in progress		
							self.syncInProgress = false;
							if (self.syncTimer == null) {
								logger.info('DSS sync process will run again in 1 minute');
								self.syncTimer = setTimeout(function() {
									self.synchroniseIntegrationsForMediaAssets(dssConfig, integrations, mediaAssets, true);
								}, 60 * 1000);
							}
							
						});
				});
			return syncDFD;
		}

		// TODO: We need to cache this locally.
		// TODO: We also need to retry this if it fails for whatever reason
		function updateDSSSchema(skipSchemaUpdate) {
			if (skipSchemaUpdate) {
				return $.Deferred().resolve(self.dssSchema);
			}
			var updateSchemaDFD = $.Deferred();
			logger.info('Updating DSS Schema..');

			if (currentTokenHasDSSClaim()) {
				doHTTPSchemaCalloutToDSSAPI()
				.then(function(schemaResponse) {
					self.dssSchema = schemaResponse
					// logger.info('DSS Schema Updated: ' + JSON.stringify(self.dssSchema, undefined, 2));
					logger.info('DSS Schema Updated: ');
					updateSchemaDFD.resolve(self.dssSchema);
				})
				.fail(function(err) {
					logger.error('Error loading Schema.');
					updateSchemaDFD.resolve(self.dssSchema);
				});
			}
			else {
				// We are going to reauth with the player API and check if the new token has the required audience
				logger.info('Attempting to reauthenticate to get token with DSS audience');
				apiInterface.authenticate(API.PLAYER_API)
					.done(function(authenticated) {
						if (authenticated && currentTokenHasDSSClaim()) {
							doHTTPSchemaCalloutToDSSAPI()
								.then(function(schemaResponse) {
									self.dssSchema = schemaResponse
									// logger.info('DSS Schema Updated: ' + JSON.stringify(self.dssSchema, undefined, 2));
									logger.info('DSS Schema Updated: ');
									updateSchemaDFD.resolve(self.dssSchema);
								})
								.fail(function(err) {
									logger.error('Error loading Schema.');
									updateSchemaDFD.resolve(self.dssSchema);
								});
						}
						else {
							logger.warning('Authentication failed or does not include DSS audience');
							updateSchemaDFD.resolve(self.dssSchema);
						}
					});
			}
			return updateSchemaDFD;
		}

		function syncIntegrationForMediaAssets(integration, mediaAssets) {
			var syncIntegrationForMediaAssetsDFD = $.Deferred();
			// TODO: Websockets if supported

			// Do sync using HTTP Polling
			logger.info('Syncing Integration: ' + integration.objectId);
			doHTTPCalloutToDSSAPI(integration)
				.then(function(response) {
					var dssResponse = response.data;
					var unmodifiedDSSResponse = JSON.stringify(dssResponse);
					// logger.info('DSS Response: ' + JSON.stringify(dssResponse, undefined, 2));
					// Store data in local file system for each media Asset
					var integrationSyncedForAllMediaAssets = $.Deferred().resolve();
					logger.info('Storing Remote Files for media assets that require access to them..');
					$.each(mediaAssets, function(index, mediaAsset) {
						// Chain the sync process for aech media asset
						integrationSyncedForAllMediaAssets = integrationSyncedForAllMediaAssets.then(function() {
							var mediaAssetIntegrationSyncDFD = $.Deferred();
							logger.info('Checking and storing data for media asset: ' + mediaAsset.name);
							// Determine and create directory
							var widgetBasePath = '';
							if (Settings.application.fileSystem.root !== "") {
								widgetBasePath += Settings.application.fileSystem.root + "/";
							}
							if (Settings.application.fileSystem.widgetDirectory !== "") {
								widgetBasePath += Settings.application.fileSystem.widgetDirectory + '/';
							}
							widgetBasePath += mediaAsset.localFileName.replace('.wgt', '');
							// Create widget integration data sub directories
							var widgetDirInfo = new DirectoryInfo(widgetBasePath);
							var integrationsDirInfo = new DirectoryInfo(widgetDirInfo.path + "/" + Settings.application.fileSystem.integrationsWidgetSubdirectory);
							var integrationNameDirInfo = new DirectoryInfo(widgetDirInfo.path + "/" + Settings.application.fileSystem.integrationsWidgetSubdirectory + "/" + integration.objectId);
							var remoteFilesSubDirectoryInfo = new DirectoryInfo(widgetDirInfo.path + "/" + Settings.application.fileSystem.integrationsWidgetSubdirectory + "/" + integration.objectId + "/" + REMOTE_FILES_SUB_DIR_NAME);// Load the widget base dir and then all create (if required) and init all sub dirs
							// Finally write the data to disk
							// And if there are Remote Files store them too
							logger.debug('Init widget dir');
							widgetDirInfo.initialize()
								.then(function() {
									logger.debug('Create sub dir');
									return widgetDirInfo.createSubDirectory(Settings.application.fileSystem.integrationsWidgetSubdirectory)
								})
								.then(function() {
									logger.debug('Init sub dir');				
									return integrationsDirInfo.initialize();
								})
								.then(function() {
									logger.debug('Create integration object dir');                    
									return integrationsDirInfo.createSubDirectory(integration.objectId);
								})
								.then(function() {
									logger.debug('Init integration object id dir');						
									return integrationNameDirInfo.initialize();
								})
								.then(function() {
									logger.debug('Create Remote Files sub dir');					
									return integrationNameDirInfo.createSubDirectory(REMOTE_FILES_SUB_DIR_NAME);
								})
								.then(function() {
									logger.debug('Init Remote Files sub dir');						
									return remoteFilesSubDirectoryInfo.initialize();
								})
								.then(function() {
									var unmodifiedDataFilePath = integrationNameDirInfo.path + "/" + UNMODIFIED_DATA_FILE_NAME;
									return checkIfTheDSSResponseHasChanged(dssResponse, unmodifiedDataFilePath)
								})
								.then(function(responseHasChanged) {
									if (responseHasChanged) {
										logger.info('Response has changed. Checking schema and downloading any remote files that are required...');
										checkSchemaAndDownloadRemoteFiles(dssResponse, remoteFilesSubDirectoryInfo.path)
											.then(function(filesInUse) {
												logger.debug('Store dss data: ' + JSON.stringify(dssResponse, undefined, 2));
												var dataFilePath = integrationNameDirInfo.path + "/" + DATA_FILE_NAME;
												File.write(dataFilePath, JSON.stringify(dssResponse))
													.then(function() {
														logger.debug('Store umodified DSS data: ' + unmodifiedDSSResponse);
														var unmodifiedDataFilePath = integrationNameDirInfo.path + "/" + UNMODIFIED_DATA_FILE_NAME;
														return File.write(unmodifiedDataFilePath, unmodifiedDSSResponse);
													})
													.then(function() {
														logger.debug('DSS Data file written. Notifying widget(s) of external data update...');
														WidgetEventController.notifyWidgetsOfExternalDataUpdate(mediaAsset, integration, dssResponse);
														return $.Deferred().resolve();
													})
													.then(function() {
														logger.debug('Reinit the remote files sub dir so we get the latest list of files');		
														remoteFilesSubDirectoryInfo = new DirectoryInfo(remoteFilesSubDirectoryInfo.path);				
														return remoteFilesSubDirectoryInfo.initialize();
													})
													.then(function() {
														logger.info('Do cleanup of any files that are no longer in use...');
														logger.info('Remote Files Path: ' + remoteFilesSubDirectoryInfo.path);
														return cleanupRemoteFilesNoLongerInUse(remoteFilesSubDirectoryInfo, filesInUse);
													})
													.then(function() {
														logger.info('Finished Syncing integration for media asset');
														mediaAssetIntegrationSyncDFD.resolve();
													})
													.fail(function(error) {
														logger.error('Error syncing integration: ' + error);
														mediaAssetIntegrationSyncDFD.resolve();
													});
											})
											.fail(function(error) {
												logger.error('Error syncing integration: ' + error);
												mediaAssetIntegrationSyncDFD.resolve();
											});
									}
									else {
										logger.info('DSS Data has not been updated. No need to update the stored data and notify the widget(s)');
										mediaAssetIntegrationSyncDFD.resolve();
									}
								})			
								.fail(function(error) {
									logger.error('Error syncing integration: ' + error);
									mediaAssetIntegrationSyncDFD.resolve();
								});
							return mediaAssetIntegrationSyncDFD;
						});
					});
					// Return a promise that resolves once all media assets that use the integration have been synced
					return integrationSyncedForAllMediaAssets;
				})
				.then(function() {
					logger.info('All data files downloaded and stored. Scheduling for resync in: ' + integration.pollFrequency * 60 * 1000 + "ms");
					// Set next time that we should try to sync
					var nextSyncTime = new Date(new Date().getTime() + integration.pollFrequency * 60 * 1000);
					logger.info('Integration: ' + integration.objectId + ' next sync time: ' + nextSyncTime);
					self.integrationSyncTimers[integration.objectId] = nextSyncTime;
					// resolve
					syncIntegrationForMediaAssetsDFD.resolve();
				})
				.fail(function() {
					logger.error('An error occurred syncing integrations. Scheduling for resync in: ' + integration.pollFrequency * 60 * 1000 + "ms");
					// Set next time that we should try to sync
					var nextSyncTime = new Date(new Date().getTime() + integration.pollFrequency * 60 * 1000);
					logger.info('Integration: ' + integration.objectId + ' next sync time: ' + nextSyncTime);
					self.integrationSyncTimers[integration.objectId] = nextSyncTime;
					// reject
					syncIntegrationForMediaAssetsDFD.reject();
				});

			return syncIntegrationForMediaAssetsDFD;
		}

		function cleanupRemoteFilesNoLongerInUse(dirInfo, remoteFilesInUse) {
			var cleanupDFD = $.Deferred();
			// Figure out if there are any old files to delete
			var filesToDelete = [];
			$(dirInfo.files).each(function(i, file) {
				var cachedRemoteFiles = $.grep(remoteFilesInUse, function(remoteFile, index) {
					logger.info('Checking: ' + remoteFile + ' === ' + file.path);
					return remoteFile === file.path;
				});

				if (cachedRemoteFiles.length != 1) {
					filesToDelete.push(file);
				}
			});
			// Delete them
			logger.info('There are ' + filesToDelete.length + ' to delete');
			// delete each file synchronously
			var dfd = $.Deferred().resolve();
			filesToDelete.forEach(function(fileToDelete) {
				dfd = dfd.then(function() {
					return fileToDelete.delete();
				});
			});
			// report that deletion process has completed
			dfd.done(function() {
				logger.info('Remote Files no longer in use removed.');
				cleanupDFD.resolve();
			});
			return cleanupDFD;
		}

		function checkIfTheDSSResponseHasChanged(latestDSSResponse, unmodifiedDataFilePath) {
			logger.info('checking if DSS response has updated...');
			var responseChangedCheckDFD = $.Deferred();
			File.read(unmodifiedDataFilePath)
				.done(function(storedResponseString) {
					try {
						var queryName = Object.keys(latestDSSResponse)[0];
						var parsedStoredData = JSON.parse(storedResponseString);

						var storedLastUpdateTime = DateTime.parse(parsedStoredData[queryName].latestSuccessfulCaptureTimestamp);
						var latestLastUpdateTime = DateTime.parse(latestDSSResponse[queryName].latestSuccessfulCaptureTimestamp);

						logger.info(storedLastUpdateTime.toString() + ' < ' + latestLastUpdateTime.toString());

						if (storedLastUpdateTime.getTime() < latestLastUpdateTime.getTime()) {
							logger.info('DSS Response has updated');
							responseChangedCheckDFD.resolve(true);
						}
						else {
							logger.info('DSS Response has not updated');
							responseChangedCheckDFD.resolve(false);
						}

					}
					catch (error) {
						logger.warning('An error occurred loading the unmodified dss response file. It may not exist. Can not check for changes so return has changed as true');
						responseChangedCheckDFD.resolve(true);
					}
				})
				.fail(function() {
					logger.warning('An error occurred loading the unmodified dss response file. It may not exist. Can not check for changes so return has changed as true');
					responseChangedCheckDFD.resolve(true);
				});
			return responseChangedCheckDFD;
		}

		function checkSchemaAndDownloadRemoteFiles(dssResponse, remoteFilesDirPath) {
			var schemaCheckDFD = $.Deferred();

			try {
				var cachedRemoteFilesInUse = [];
				logger.debug('Checking Schema and Handling Remote Files');
				var queryName = Object.keys(dssResponse)[0];
				var returnObjectTypeDefinition = getQueryReturnObjectTypeDefinitionFromSchema(self.dssSchema, queryName);
				// If we have no matching return type then there are no RemoteFile types to check
				if (returnObjectTypeDefinition == null) {
					logger.info('No matching return object type or return object type is not an object');
					return schemaCheckDFD.resolve();
				}
				// Get a list of any RemoteFiles we need to process
				var currentPath = ['webpage'];
				var remoteFileTypes = findRemoteFileTypesInReturnType(returnObjectTypeDefinition.fields, currentPath, self.dssSchema.data.__schema.types);
				logger.debug(JSON.stringify(remoteFileTypes, undefined, 2));
				// If we have no remote files to download then just resolve here
				if (remoteFileTypes.length === 0) {
					logger.info('There are no remote files to download');
					return schemaCheckDFD.resolve();
				}
				// Otherwise we need to download the remote files and update the dss response with the local file urls
				var downloadedRemoteFiles = $.Deferred().resolve();
				for (var i = 0; i < remoteFileTypes.length; i++) {
					var remoteFile = remoteFileTypes[i];
					logger.debug('Processing remote file: ' + JSON.stringify(remoteFile, undefined, 2))
					var dssResponseRemoteFile = getNestedObject(dssResponse, remoteFile.pathParts);
					logger.debug('Remote file object: ' + JSON.stringify(dssResponseRemoteFile, undefined, 2));
					downloadedRemoteFiles = downloadedRemoteFiles.then(function () {
						return DownloadRemoteFile(dssResponseRemoteFile, remoteFilesDirPath, cachedRemoteFilesInUse)
					});
				}
				// When all RemoteFiles have been downloaded
				downloadedRemoteFiles
					.done(function () {
						logger.info('All remote files downloaded');
						schemaCheckDFD.resolve(cachedRemoteFilesInUse);
					})
					.fail(function (err) {
						logger.error('An error occurred processing all remote files');
						schemaCheckDFD.reject();
					});
			} catch (err) {
				logger.error('An error occurred checking the DSS schema and downloading remote files');
				schemaCheckDFD.reject();
			}
			return schemaCheckDFD;
		}

		function DownloadRemoteFile(remoteFile, integrationNameDirInfoPath, cachedRemoteFilesInUse) {
			var downloadFileDFD = $.Deferred();
			var destPath = integrationNameDirInfoPath + "/" + remoteFile.name;
			// Do Download
			new Downloader().downloadFile(remoteFile.url, destPath)
				.then(function(remotePath, localPath) {
					logger.info('Get play URL for: ' + localPath);
					// Add to remote files that are in use so we can ensure we do not delete it
					cachedRemoteFilesInUse.push(localPath);					
					// Get local play url for media file
					return PlayUrlHelper.getFileUrlForVirtualPath(localPath);
				})
				.then(function(playUrl) {
					logger.info('Update screenshot src to: ' + playUrl);						
					// Timestamp the playUrl to force an update
					playUrl += '?' + new Date().getTime();
					// update dss response with local play url rather than remote url
					remoteFile.url = playUrl;
					downloadFileDFD.resolve();
				})
				.fail(function(err) {
					// TODO: Check this case
					logger.error('Error downloading remote file: ' + err);
					downloadFileDFD.reject();
				});

			return downloadFileDFD;
		}

		function getNestedObject(nestedObj, pathArr) {
			return pathArr.reduce(
				function(obj, key) {
					return (obj && obj[key] !== 'undefined')
						? obj[key]
						: null
				},
				 nestedObj
			);
		  };
		
		// This method recurively iterates the return type and any nested types to find any fields that are of the matching type
		// It then returns the path to these fields which allows us to handle these fields as special cases
		function findRemoteFileTypesInReturnType(fields, currentPath, schemaTypes) {
			// Init Properties
			var resultsArray = [];
			if (currentPath == null) {
				currentPath = [];
			}
			// Iterate array of fields
			for (var i = 0; i < fields.length; i++) {
				var field = fields[i];
				// This is the case where we have found a Remote File so add it to the results array
				if  (field.type && field.type.kind === "OBJECT") {
					// Store the path as we will need it as this will either be a rmeote file or an object we need to traverse recursively
					currentPath.push(field.name);
					// This is a remote file type so this is a property we need to store
					if (field.type.name === REMOTE_FILE_TYPE_NAME) {
						resultsArray.push({
							fieldName: currentPath.join('.'),
							pathParts: currentPath
						});
					}
					// This is an object so we need to check for nested types
					else {
						// Find the type defined
						var matchingType = schemaTypes.find(function(type) { 
							return type.kind === "OBJECT" && type.name === field.type.name
						});
						// Call recursively
						if (matchingType) {
							resultsArray = resultsArray.concat(findRemoteFileTypesInReturnType(REMOTE_FILE_TYPE_NAME, matchingType.fields, currentPath, schemaTypes));
						}
					}
				}
			}
			return resultsArray;
		}

		function getQueryReturnObjectTypeDefinitionFromSchema(schemaObj, queryName) {
			// Get the Query Object which will contain all queries defined in the schema
			var schemaAllQueriesDefinition = schemaObj.data.__schema.types.find(function(type) { 
				return type.kind === "OBJECT" && type.name === "Query"
			});
			// Find the details for the query that matches our current query
			var matchingQuerySchemaDefinition = schemaAllQueriesDefinition.fields.find(function(queryDef) {
				return queryDef.name === queryName
			});
			if (matchingQuerySchemaDefinition == null) {
				logger.error('Unable to find matching query object in schema');
				return null;
			}
			// console.log(JSON.stringify(matchingQuerySchemaDefinition, undefined, 2));
			// We only need to check for custom types if the response object is of type object
			if (matchingQuerySchemaDefinition.type.kind === "OBJECT") {
				// Get details of the return object type - first we need to get the name so we can get the details
				var matchingQueryReturnObjectTypeName = matchingQuerySchemaDefinition.type.name;
				var returnObjectTypeDefinition = schemaObj.data.__schema.types.find(function(type) { 
					return type.kind === "OBJECT" && type.name === matchingQueryReturnObjectTypeName
				});
				if (returnObjectTypeDefinition == null) {
					logger.error('Unable to find matching return object type');
					return null;
				}
				logger.debug(JSON.stringify(returnObjectTypeDefinition, undefined, 2));
				return returnObjectTypeDefinition;
			}
		}

		function doHTTPCalloutToDSSAPI(integration) {
			try {
				var postUrl = self.dssConfig.dataApiUrl;
				logger.info('POST URL: ' + postUrl);
				return $.ajax({
					url: postUrl,
					data: JSON.stringify({
						query: integration.dssQuery
					}),
					processData: false,
					type: 'POST',
					contentType: 'application/json',
					timeout: 60000,
					beforeSend: function(xhr) {
						xhr.setRequestHeader('Authorization', 'Bearer ' + Settings.application.api.authToken);
					}
				});
			}
			catch (error) {
				logger.error(error);
                return $.Deferred().reject(error);
			}
		}

		function doHTTPSchemaCalloutToDSSAPI() {
			try {
				var postUrl = self.dssConfig.dataApiUrl;
				logger.info('POST URL: ' + postUrl);
				return $.ajax({
					url: postUrl,
					data: JSON.stringify({
						query: SCHEMA_QUERY
					}),
					processData: false,
					type: 'POST',
					contentType: 'application/json',
					timeout: 60000,
					beforeSend: function(xhr) {
						xhr.setRequestHeader('Authorization', 'Bearer ' + Settings.application.api.authToken);
					}
				});
			}
			catch (error) {
				logger.error('Error calling out to check dss schema');
				return $.Deferred().reject();
			}	
		}

		function currentTokenHasDSSClaim() {
			var tokenModel = new TokenModel(Settings.application.api.authToken);
			return tokenModel.hasClaim(TokenClaims.DSS);
		}
	}
	return new DSSAPIInterface();
});
