define(["system/remotecontrol/RemoteControlInterface"], function(RemoteControlInterface) {
	/**
	 * [Button description]
	 * @param {[type]} id        [description]
	 * @param {[type]} label     [description]
	 * @param {[type]} callbacks [description]
	 */
	function Button(id, label, callbacks) {
		var self = this;
		self.id = id;
		self.label = label;
		self.callbacks = callbacks;
		self.hasFocus = false;

		self.html = '<div id="' + self.id + '" class="button">' + self.label + '</div>';

		/**
		 * [select description]
		 * @return {[type]} [description]
		 */
		self.select = function() {
			self.hasFocus = true;

			$('#' + self.id).addClass('selected');
		};

		/**
		 * [deselect description]
		 * @return {[type]} [description]
		 */
		self.deselect = function() {
			self.hasFocus = false;

			$('#' + self.id).removeClass('selected');
		};
		
		/**
		 * [hoverOn description]
		 * @return {[type]} [description]
		 */
		self.hoverOn = function() {
			$('#' + self.id).addClass('hover');
		};
		
		/**
		 * [hoverOff description]
		 * @return {[type]} [description]
		 */
		self.hoverOff = function() {
			$('#' + self.id).removeClass('hover');
		};

		self.addedToCanvas = function() {
		};

		/**
		 * [handleKeyPress description]
		 * @param  {[type]} keyCode [description]
		 * @return {[type]}         [description]
		 */
		self.handleKeyPress = function(keyCode) {
			var keys = null;
			try {
				keys = RemoteControlInterface.keys;
				if (keyCode == keys.KEY_ENTER || keyCode == keys.KEY_PANEL_ENTER) {
					self.callbacks.click();
				}
			} catch(e) {

			}
		};
	}

	return Button;
});
