define(["system/remotecontrol/RemoteControlInterface"], function(RemoteControlInterface) {
	function Checkbox(id, checked) {
		var self = this;
		self.id = id;
		self.checked = checked;
		self.hasFocus = false;

		var viewHtml = '<div id="' + self.id + '" class="control checkbox" style="width:100px">';
		viewHtml += '<div class="display"><div class="checkmark">&#10004;</div></div>';
		viewHtml += '</div>';
		self.html = viewHtml;

		self.select = function() {
		};

		self.deselect = function() {
		};

		self.hoverOn = function() {
			self.hasFocus = true;
			$('#' + self.id).addClass('hover');
		};

		self.hoverOff = function() {
			self.hasFocus = false;
			$('#' + self.id).removeClass('hover');
		};

		self.check = function() {
			$('#' + self.id + ' .checkmark').addClass('checked');
			$('#' + self.id + ' .checkmark').removeClass('unchecked');
			self.checked = true;
		};

		self.uncheck = function() {
			$('#' + self.id + ' .checkmark').removeClass('checked');
			$('#' + self.id + ' .checkmark').addClass('unchecked');
			self.checked = false;
		};

		self.addedToCanvas = function() {
			if (self.checked) {
				self.check();
			} else {
				self.uncheck();
			}
		};

		self.handleKeyPress = function(keyCode) {
			var keys = null;
			try {
				keys = RemoteControlInterface.keys;
				switch(keyCode)
				{
					case keys.KEY_ENTER:
						// toggle selection
						if($('#' + self.id).prop("disabled") !== true) {
							if (self.checked) {
								self.uncheck();
							} else {
								self.check();
							}
						}
					break;	
				}
			} catch(e) {

			}
		};
	}

	return Checkbox;
});
