define(['lib/knockout', "system/remotecontrol/RemoteControlInterface"], function(ko, RemoteControlInterface) {
	function ComboBox(id, data, itemSelected) {
		var self = this;
		self.id = id;

		var viewHtml = '<div id=' + self.id + ' style="width:100%">';
		viewHtml += '<div style="width:720px;margin: 0 auto;">';
		viewHtml += '<div class = "roller" style="width:670px">';
		viewHtml += '<div class="display" style="font-size: 25px;" data-bind="text: displayName"></div>';
		viewHtml += '</div>';
		viewHtml += '</div>';

		viewHtml += '</div>';
		self.html = viewHtml;

		var _selectedItemIndex = 0;
		var _dataItemCollection = data;

		var _selectedItem = ko.observable(itemSelected);

		self.addedToCanvas = function() {
			// get the selected index
			$(_dataItemCollection).each(function(i, item) {
				if (item.id == self.selectedItem().id) {
					_selectedItemIndex = i;
				}
			});

			ko.applyBindings(_selectedItem, $('#'+self.id)[0]);
		};

		self.selectedItem = function() {
			return _selectedItem();
		};
		
		self.hoverOn = function() {
			$('#' + self.id + ' .roller').addClass('hover');
			$('#' + self.id + ' .roller').addClass('smaller-margin');
			$('#' + self.id + ' .display').addClass('selecteddisplay');
		};
		
		self.hoverOff = function() {
			$('#' + self.id + ' .roller').removeClass('hover');
			$('#' + self.id + ' .display').removeClass('selecteddisplay');
			$('#' + self.id + ' .roller').removeClass('smaller-margin');
		};

		self.select = function() {
			$('#' + self.id + ' .roller').removeClass('hover');
			$('#' + self.id + ' .roller').addClass('selected');
		};

		self.deselect = function() {
			$('#' + self.id + ' .roller').removeClass('selected');
			$('#' + self.id + ' .roller').addClass('hover');
		};

		self.handleKeyPress = function(keyCode) {
			var keys = null;
			try {
				keys = RemoteControlInterface.keys;
				switch(keyCode) {
					case keys.KEY_UP:
						_selectedItemIndex--;
						if (_selectedItemIndex < 0)
							_selectedItemIndex = _dataItemCollection.length - 1;

						_selectedItem(_dataItemCollection[_selectedItemIndex]);

						break;

					case keys.KEY_DOWN:
						_selectedItemIndex++;
						if (_selectedItemIndex == _dataItemCollection.length)
							_selectedItemIndex = 0;

						_selectedItem(_dataItemCollection[_selectedItemIndex]);
						break;
				}
			} catch(e) {

			}
		};
	}

	return ComboBox;
});
