define([], function() {
	function TVPlayer(parentId, x, y, width, height, zIndex) {
		
		var self = this;
		var $tvViewer;
		self.id = parentId + "_tvViewer";
		self.zIndex = zIndex;
		self.initialized = false;

		// Don't do anything straight away
		self.play = function() {

			// Add black div
			if (!$("#" + self.id + "_container").length) {
				$("body").append("<div id='" + self.id + "_container' style='background-color:#000;visibility:hidden;position:absolute;left:" + x + "px;top:" + y + "px;width:" + width + "px;height:" + height + "px; z-index: " + self.zIndex +";'></div>");
			}

			// Only need to do something here if not initialized
			if (!self.initialized) {

				var options = {
					divId: self.id + "_container",
					videoId: self.id,
					callback: function() {}, // Don't really know what to use this callback for
					isLastChannel : false,
					src: "ext://hdmi:1", // Always use HDMI as no UI to change this
					noaudio: false
				};

				logger.debug("Capture Initialization options: " + JSON.stringify(options));

				// Remove the old element as the initialization will add a new one with the same ID
				$("#" + self.id).remove();

				// Initialize (which will auto start playback)
				new InputSource().initialize(
					// Success
					function(successResult) {
						logger.debug("HDMI Input source initialised successfully.");

						// Initialization finished
						self.initialized = true;

						// set tvViewer
						$tvViewer = $("#" + self.id);

						// Make sure viewer is not hidden
						self.show();

						// Hide div
						//$("#" + self.id + "_blackBox").remove();


					},
					// Failed To initialize
					function(failedResult) {
						logger.error("HDMI Input source initialised failed. Error: [" + failedResult.errorCode + "] " + failedResult.errorText);
						self.initialized = false;
					},
					// Input Initialisation Options
					options
				);
			}
			else {
				self.show();
			}
		};

		self.stop = function() {
			if (self.initialized) {
				self.initialized = false;
			}
		};

		self.setInitialized = function(initialized) {
			self.initialized = initialized;
		};

		self.setMute = function(muted) {
			if (self.initialized)
				$tvViewer[0].muted = muted;
		};

		self.volumeUp = function() {

		};

		self.volumeDown = function() {

		};

		self.show = function() {
			if (self.initialized) {
				$tvViewer.css('visibility', 'visible');
			}
		};

		self.hide = function() {
			if (self.initialized) {
				$tvViewer.css('visibility', 'hidden');
			}
		};
	}

	return TVPlayer;
});
