define(["system/DateTime", 'gui/viewmodels/DevicePropertiesViewModel'], function(DateTime, DevicePropertiesViewModel) {
    /*
    	Device Properties View
    	----------------------------------------
     */
    function DevicePropertiesView() {

        var self = this;
        self.id = 'devicePropertiesView';

        //
        // Initialize View - This now uses deferred objects so that we can get underlying data like network info Asynchronously
        //
        self.initialize = function() {

            var dfd = $.Deferred();

            // Generate the DevicePropertiesViewModel
            deviceProperties = new DevicePropertiesViewModel();
            deviceProperties.generate().always(function() {

                // Configure HTML
                var viewHtml = '<div id="' + self.id + '" style="background-color:rgba(0,0,0,0.8);color:#ffffff;position:absolute;width:100%;left:0px;top:0px; word-wrap:break-word;font-size:16px;z-index:29;">';
                viewHtml += "<table style='margin-left:auto;margin-right:auto;text-align:left'>";
                viewHtml += "<tr><td>Current Time:</td><td>" + DateTime.now() + "</td></tr>";
                viewHtml += "<tr><td>Model Number:</td><td>" + deviceProperties.modelNumber + "</td></tr>";
                viewHtml += "<tr><td>Firmware Version:</td><td>" + deviceProperties.firmwareVersion + "</td></tr>";
                viewHtml += "<tr><td>Package Type:</td><td>" + deviceProperties.packageType + "</td></tr>";
                viewHtml += "<tr><td>webOS Version:</td><td>" + deviceProperties.webOSVersion + "</td></tr>";
                viewHtml += "<tr><td>SDK Version:</td><td>" + deviceProperties.sdkVersion + "</td></tr>";
                viewHtml += "<tr><td>Signagelive Serial Number:</td><td>" + deviceProperties.signageliveSerialNumber + "</td></tr>";
                viewHtml += "<tr><td>Signagelive Version:</td><td>" + deviceProperties.clientVersion + "</td></tr>";
                viewHtml += "<tr><td>Signagelive Build:</td><td>" + deviceProperties.buildNumber + "</td></tr>";
                viewHtml += "<tr><td>IP Address: </td><td>" + deviceProperties.ipv4_address + "</td></tr>";
                viewHtml += "<tr><td>MAC Address: </td><td>" + deviceProperties.macAddress + "</td></tr>";
                viewHtml += "<tr><td>Change ID: </td><td>" + deviceProperties.changeId + "</td></tr>";
                viewHtml += "</table>";
                viewHtml += '</div>';

                // Store in self.html
                self.html = viewHtml;

                // Resolve initialisation
                dfd.resolve();

            });

            return dfd;
        };
    }

    return DevicePropertiesView;
});