define(["gui/views/LayerBase", "gui/views/SVGConstants"], function(LayerBase, SVGConstants) {
	function SVGLayerBase(zoneViewModel) {
		// init the parent object
		this.parent = new LayerBase(zoneViewModel);
		// copy all properties so they are available
		for (var property in this.parent) {

			if (property != 'prototype' & property != 'parent')
				this[property] = this.parent[property];
		}

		this.svgElem = null;
		this.bgElement = null;

		this.svgElem = document.createElementNS(SVGConstants.XmlNS, "svg");
		this.svgElem.setAttributeNS(null, "viewBox", "0 0 " + this.width + " " + this.height);
		this.svgElem.setAttributeNS(null, "width", this.width);
		this.svgElem.setAttributeNS(null, "height", this.height);
		this.svgElem.setAttributeNS(null,"preserveAspectRatio","none");
		this.svgElem.style.display = "block";

		var baseElement = document.getElementById(this.id);
		baseElement.appendChild(this.svgElem);
	}

	return SVGLayerBase;
});
