define(function() {
	function ConnectivityModel(data) {
		var self = this;
		self.configurationCheckTime = data.configuration_check_time;
		self.configurationCheckInterval = data.configuration_check_interval;

		// convert minutes to milliseconds
		if (self.configurationCheckInterval != null)
			self.configurationCheckInterval = data.configuration_check_interval * 60000;

		self.configurationIntervalScheme = data.configuration_interval_scheme;

		self.healthCheckInterval = Math.max(data.health_check_interval * 60000, 60000);

		self.diagnosticsUpdateTime = data.diagnostics_update_time;
		self.diagnosticsUpdateInterval = data.diagnostics_update_interval;
		
		// convert minutes to milliseconds
		if (self.diagnosticsUpdateInterval != null)
			self.diagnosticsUpdateInterval = data.diagnostics_update_interval * 60000;		
		
		self.diagnosticsUpdateIntervalScheme = data.diagnostics_interval_scheme;

		self.scheduledRebootsEnabled = data.scheduled_reboots_enabled;
		self.systemRebootTime = data.system_reboot_time;
		self.instantReboot = data.instant_reboot;

	}

	return ConnectivityModel;
});
