define(["properties/App.Properties","system/SystemInterface", "properties/App.Settings"], function(Properties,SystemInterface, Settings) {
	function DeviceInfoModel()
	{
		var self = this;
		self.manufacturer = "";
		self.model = "";
		self.client_version = Properties.appVersion;
        self.firmware_version = "";
        self.client_id =  Settings.application.api.clientId;

        self.generate = function() {
            var dfd = $.Deferred();

            SystemInterface.getOSVersion().done(function(osVersion){
                self.firmware_version = osVersion;
                }).always(function(){

                    // Get manufacturer
                    SystemInterface.getManufacturer().done(function(manufacturer){
                        self.manufacturer = manufacturer;
                    }).always(function() {
                        SystemInterface.getModel().done(function(modelName){
                            self.model = modelName;
                        }).always(function() {
                            dfd.resolve();
                        });
                    });
            });
            
			return dfd;
		};
    }

    return DeviceInfoModel;
});
