define(["models/MediaTypeConstants"], function(MediaTypeConstants) {
    function MimeTypeMediaTypeMappings() {
        var self = this;
        self.getMediaType = function(mime) {
            switch (mime) {
                case "image/png":
                case "image/jpg":
                case "image/bmp":
                case "image/svg+xml":
                case "image/tiff":
                    return MediaTypeConstants.IMAGE;
                case "video/x-ms-wmv":
                case "video/avi":
                case "video/divx":
                case "video/mp4":
                case "video/mp2t":
                case "video/m4v":
                case "video/x-m4v":
                case "video/x-matroska":
                case "video/quicktime":
                case "video/webm":
                case "video/mpeg":
                    return MediaTypeConstants.VIDEO;
                case "application/rss+xml":
                    return MediaTypeConstants.RSS;
                case "application/vnd.signagelive.iptv":
                    return MediaTypeConstants.IPTV;
                case "text/html":
                    return MediaTypeConstants.WEB;
                case "application/vnd.signagelive.capture":
                    return MediaTypeConstants.CAPTURE;
                case "application/widget":
                    return MediaTypeConstants.WIDGET;
                case "application/vnd.signagelive.feed":
                    return MediaTypeConstants.FEED;

            }
        };

        self.getMimeTypeTypeByFileExt = function(ext) {
            switch (ext) {
                // Images
                case "tif":
                case "tif":
                    return "image/tiff";
                case "png":
                    return "image/png";
                case "jpg":
                case "jpeg":
                    return "image/jpeg";
                case "gif":
                    return "image/gif";
                case "bmp":
                case "bm":
                    return "image/bmp";
                case "svg":
                    return "image/svg+xml";

                    // Videos
                case "mp4":
                    return "video/mp4";
                case "webm":
                    return "video/webm";
                case "mpg":
                case "mpeg":
                    return "video/mpeg";
                case "avi":
                    return "video/avi";

                    // Text
                case "js":
                    return "text/javascript";
                case "css":
                    return "text/css";
                case "html":
                case "htm":
                case "htmls":
                    return "text/html";
                case "xml":
                    return "text/xml";
                default:
                    return "text/plain";

                case "json":
                    return "application/json";
                case "txt":
                    return "text/plain";
            }
        };
    }

    return new MimeTypeMediaTypeMappings();
});