define(["properties/App.Settings", "models/MediaTypeConstants", "models/RssChannelModel"], function(Settings, MediaTypeConstants, RssChannel) {
	function RssChannelCache() {
		var self = this;

		self.loadRssAssetIntoCache = function(asset) {
			if (asset.contentType != MediaTypeConstants.RSS)
				return;

			try {
				// NOTE - need to use the AJAX call to load the xml as there have been instances where byte order mark is the first characted retured in the
				// xml jquery.parseXML does not handle this whereas ajax does.
				$.ajax({
					url : './content/' + asset.localFileName,
					type : 'GET',
					dataType : "xml",
					async : false
				}).done(function(data, textStatus, jqXHR) {
					logger.debug('RSS loaded ' + data);
					if (data != null) {
						var rssChannel = new RssChannel(data);
						self[asset.externalId] = rssChannel;
					}
				}).fail(function(jqXHR, textStatus, errorThrown) {
					logger.error('Error loading RSS feed');
				});

			} catch(e) {
				logger.error('Error loading RSS Feed ' + e.message);
			}
		};
	}

	var cache = new RssChannelCache();
	return cache;
});
