define(["properties/App.Settings", "models/RssItemModel"], function(Settings, RssItemModel) {
	function RssChannelModel(data) {
		var self = this;

		self.title = $(data).children('rss').children('channel').children('title').text();

		self.items = [];
		$(data).find('item').each(function(index, item) {
			var rssItem = new RssItemModel(item);
			if (item.title != '') {
				self.items.push(rssItem);
			}
		});
	}

	RssChannelModel.load = function(file) {
		var rssChannel = null;
		try {
			// NOTE - need to use the AJAX call to load the xml as there have been instances where byte order mark is the first characted retured in the
			// xml jquery.parseXML does not handle this whereas ajax does.
			$.ajax({
				url : file,
				type : 'GET',
				dataType : "xml",
				async : false
			}).done(function(data, textStatus, jqXHR) {
				logger.debug('RSS loaded ' + data);
				if (data != null) {
					rssChannel = new RssChannelModel(data);
				}
			}).fail(function(jqXHR, textStatus, errorThrown) {
				logger.error('Error loading RSS feed');
			});

		} catch(e) {
			logger.error('Error loading RSS Feed ' + e.message);
		}

		return rssChannel;
	};

	return RssChannelModel;
});
