define(["properties/App.Settings", "models/StorageTypeConstants","system/io/FileEx"], function(Settings, StorageType,File) {
	/**
	 * Used to manage the Local File List Manifest
	 */
	function ScreenshotFileList() {
		
		/**
		 *
		 * 
		 * TO-DO: LOOK IN LG STORAGE FIX (REOPENED) BRANCH FOR CHANGES TO FILESYTEM FOR READING AND WRITING FILES, INSTEAD OF RELYING ON LOCAL STORAGE
		 * 
		 * 
		 *  
		 */
		
		
		var self = this;
		self.files = [];
		
	/*	// Load the screenshot manifest file
		if (localStorage[Settings.application.fileSystem.systemFiles.screenshotFileListFilePath] != undefined)
		{
			self.files = JSON.parse(localStorage[Settings.application.fileSystem.systemFiles.screenshotFileListFilePath]);

		}
		*/
		
		
		/**
		 * Add a file to the file manifest
		 * @param {[type]} path [description]
		 */
		self.add = function(created,tz,ondemand,rotation,data)  {
			var dfd = $.Deferred();
			
			loadData().done(function()
			{
				logger.info("Data is loaded, checking if screenshot is already in list (it shouldn't be)");
				// If the file doesn't already exist in the manifest file then add it
				if (exists(created) == false) {
					logger.info("Screenshot is not in list, adding to file list");	
					self.files.push({
						created : created,
						tz: tz,
						ondemand: ondemand,
						rotation: rotation,
						data : data
					});
					
					logger.info("Screenshot added, saving...");
					
					saveFileSystemEnties().done(function(){
						logger.info("Screenshot saved. Screenshots in file: " + self.files.length);
						dfd.resolve();
					}).fail(function()
					{
						dfd.reject();
					});	
				} else {
					//Already in list?
					dfd.resolve();
				}	
			});
			
			return dfd.promise();
		};
		
		self.count = function() {
			var dfd = $.Deferred();
			
			loadData().done(function()
			{
				dfd.resolve(self.files.length);
			});
			
			return dfd.promise();
		};
		
		/**
		 * Gets the first item without removing it
		 */
		self.getFirst = function() {

			var dfd = $.Deferred();
			
			loadData().done(function()
			{
				if(self.files.length > 0)
					dfd.resolve(self.files[0]);
				else 
					dfd.resolve(null);						
			});
			
			return dfd.promise();		
		};
		
		self.getFirstXItems = function(itemCount) {
			var dfd = $.Deferred();
			
			loadData().done(function()
			{
				if(self.files.length > 0)
					dfd.resolve(self.files.slice(0,itemCount));
				else 
					dfd.resolve(null);
					
			});
			
			return dfd.promise();		
		};
		
		
				//Remove and get first item
		self.removeFirst = function() 
		{				
			var dfd = $.Deferred();
			
			loadData().done(function()
			{
				if(self.files.length > 0)
				{
					var item = self.files.shift();
					saveFileSystemEnties().done(function(){
						dfd.resolve(item);
					}).fail(function()
					{
						dfd.reject();
					});	
				} else 
					dfd.resolve(null);
			});
					
			return dfd.promise();
		};
	
		/**
		 * Remove a file from the file manifest
		 * @param  {[type]} path [description]
		 * @return {[type]}      [description]
		 */
		self.remove = function(created) {
			var dfd = $.Deferred();
			
			loadData().done(function()
			{
				// Check for matching files in the manifest
				var index = -1;
				indexes = $.map(self.files, function(obj, index) {
					if (obj.created == created) {
						return index;
					}
				});
	
				// If a match is found get the first match
				if (indexes.length > 0)
					index = indexes[0];
	
				// And delete it
				if (index != -1) {
					self.files.splice(index, 1);
					saveFileSystemEnties().done(function(){
						dfd.resolve();
					}).fail(function()
					{
						dfd.reject();
					});	
				}else{
					dfd.resolve();
				}	
			
			});
			
			
			return dfd.promise();
		};
		
		self.removeMultipleScreenshots = function(screenshotArray) {
			var dfd = $.Deferred();
			
			//Load the files, delete each in the array and save the file again
			loadData().done(function()
			{	
				try{
				screenshotArray.forEach(function(screenshot){
					// Check for matching files in the manifest
					var index = -1;
					indexes = $.map(self.files, function(obj, index) {
						if (obj.created == screenshot.created) {
							return index;
						}
					});
		
					// If a match is found get the first match
					if (indexes.length > 0)
						index = indexes[0];
		
					// And delete it
					if (index != -1) {
						logger.debug("Removing screenshot taken at " + screenshot.created);
						self.files.splice(index, 1);					
					}
				});
				
				} catch(e)
				{
					logger.error(e.message);
				}
				
				logger.debug("Screenshots removed, saving");
				saveFileSystemEnties().done(function(){
					logger.debug("Screenshot list saved");
					dfd.resolve();
				}).fail(function()
				{
					dfd.reject();
				});		

			});
			
			
			return dfd.promise();
		};

		/**
		 *DATA MUST BE LOADED FIRST 
		 *
		 * Does the file exist?
		 * @param  {[type]} path [description]
		 * @return {[type]}      [description]
		 */
		function exists(created) {

			var exists = false;
			var matches = $.grep(self.files, function(obj, index) {
				return obj.created == created;
			});
			return (matches.length == 1);
		};
		
		function loadData()
		{
			var dfd = $.Deferred();
			
			File.read(Settings.application.fileSystem.systemFiles.screenshotFileListFilePath).done(function(data) {
				//Not a few file
				if (data != null && data != "")
				{
					logger.info("Screenshot list loaded. Attempting to parse screenshot file list...");
					
					try {
						self.files = JSON.parse(data);
						logger.info("Screenshot list parsed successfully.");
					}
					catch (e)
					{
						logger.error("Error parsing file data. Resetting file list. Error: " + e.message);
						self.files = [];
					}
				}
				else
				{
					logger.info("No screenshots to load. Resetting file list.");
					self.files = [];
				}
				
				dfd.resolve();
			})
			.fail(function() {
				logger.error('Error reading screenshot file. Resettig file list.');
				self.files = [];
				dfd.resolve();
			});
			
			return dfd.promise();
		}

		/**
		 * [saveFileSystemEnties description]
		 */
		function saveFileSystemEnties() {
			
			var dfd = $.Deferred();
					
			File.write(Settings.application.fileSystem.systemFiles.screenshotFileListFilePath,JSON.stringify(self.files)).done(function()
			{
				logger.info("Screenshot list saved");
				dfd.resolve();
			}).fail(function()
			{
				logger.error("Error saving the screenshot file list");
				dfd.reject();
			});
	
			
			return dfd.promise();
		}

	}

	var sfl = new ScreenshotFileList();
	return sfl;
});
