define(["models/ScheduledPlaylistModel"],function(ScheduledPlaylistModel) {
	function ZoneModel(data) {
		var self = this;
		self.externalId = data.id;
		self.x = data.x;
		self.y = data.y;
		self.width = data.width;
		self.height = data.height;
		self.zIndex = data['z-index'];
		if(self.zIndex === undefined)
		{
			self.zIndex = 0;
		}
		
		self.type = data.type;
		self.backgroundAssetId = data.background_asset_id;
		self.backgroundAsset = null;		
		
		self.includeInProofOfPlay = data.include_in_proof_of_play;
		
		self.seperatorAsset = null;
		
		self.configurationParameters = data.configuration_parameters;		

		self.defaultMediaAssetId = data.default_media_asset_id;
		self.defaultMediaAsset = null;
		self.defaultPlaylistId = data.default_playlist_id;
		self.defaultPlaylist = null;
		
		self.scheduledPlaylists = [];

		$(data.scheduled_playlists).each(function(index, value) {
			var scheduledPlaylist = new ScheduledPlaylistModel(value);
			self.scheduledPlaylists.push(scheduledPlaylist);
		});
	}

	return ZoneModel;
});
