define([], function() {
    function IDConverter() {
        var self = this;
        var _power = 62;

        if (!String.prototype.padStart) {
            String.prototype.padStart = function padStart(targetLength, padString) {
                targetLength = targetLength >> 0; //truncate if number, or convert non-number to 0;
                padString = String(typeof padString !== 'undefined' ? padString : ' ');
                if (this.length >= targetLength) {
                    return String(this);
                } else {
                    targetLength = targetLength - this.length;
                    if (targetLength > padString.length) {
                        padString += padString.repeat(targetLength / padString.length); //append to original to ensure we are longer than needed
                    }
                    return padString.slice(0, targetLength) + String(this);
                }
            };
        }

        self.getObjectId = function(hex) {
            hex = hex.substring(3);
            return self.toInt(hex);
        }

        self.toInt = function(hex) {
            var returnValue = 0;
            for (var i = 0; i < hex.length; i++) {

                var num1 = 62;
                var num2 = (hex.length - (i + 1));
                var num3 = CharToVal(hex[i]);

                returnValue += Math.pow(num1, num2) * num3;
            }
            return returnValue;
        }

        self.toHex = function(objectTypeId, objectId) {
            try {
                var objectTypeIdHex = _toHex(objectTypeId).padStart(3, '0');
                var objectIdHex = _toHex(objectId).padStart(11, '0');
                return objectTypeIdHex + objectIdHex;
            } catch (e) {
                return e.message;
            }
        }

        function _toHex(value) {
            try {
                var x = parseInt(value % _power, 10);
                var y = parseInt(value / _power, 10);
                if (y > 0)
                    return _toHex(y) + ValToChar(x);
                else {
                    return ValToChar(x);
                }
            } catch (e) {
                log(e.message)
            }

        }

        function ValToChar(value) {
            if (value > 9) {
                var ascii = (65 + (value - 10));
                if (ascii > 90)
                    ascii += 6;
                return String.fromCharCode(ascii);
            } else
                return value.toString();
        }

        function CharToVal(value) {

            var chrval = value.charCodeAt(0);
            if (chrval > 96)
                return (chrval - 71) + 10;
            else if (chrval > 64)
                return (chrval - 65) + 10;
            else
                return parseInt(value, 10);
        }
    }
    return IDConverter;
});