define(function() {
    function ClockInterface() {

        var self = this;

        self.getTimeZone = function() {

            var dfd = $.Deferred();

            logger.warning('ClockInterface.getTimeZone() called but not implemented');
            dfd.reject();

            return dfd;
        };

        self.setTimeZone = function(tzID, tz) {
            var dfd = $.Deferred();

            try
            {
                if (tz && tz.continent && tz.country && tz.city)
                {
                    logger.info('Setting timezone to: Continent: ' + tz.continent + ', Country: ' + tz.country + ', City: ' + tz.city);
                    new Configuration().setTimeZone(
                        // Success
                        function(result)
                        {
                            logger.info('Timezone updated successfully');
                            dfd.resolve();
                        },
                        // Error
                        function(result)
                        {
                            var errorCode = result.errorCode;
                            var errorText = result.errorText;
                            logger.error("Error Code [" + errorCode + "]: " + errorText);
                            dfd.reject();
                        },
                        // Options
                        {
                            timeZone: tz
                        }
                    )
                }
                else
                {
                    logger.warning('Unable to update timezone as provided timezone object is invalid');
                    dfd.reject();
                }
            }
            catch (e)
            {
                logger.error(e);
                dfd.reject();
            }
            return dfd;
        };
    }
    return new ClockInterface();
});