define(function() {
	/*
		CPUInterface provides access to low level CPU Information
	 */
	function CPUInterface() {

		var self = this;

		//
		//	Returns CPU Speed. Again, LG SDK Does not provide this so just return a value for now
		//
		self.getCPUSpeed = function() {

			var dfd = $.Deferred();
     
		    setTimeout(function(){
		    	var cpuSpeed = 1000;
		    	logger.info("CPU Interface: CPU Speed: " + cpuSpeed);
		    	dfd.resolve(cpuSpeed);
		    }, 100);

		    return dfd;
		};

		//
		//	Returns CPU Usage. Again, LG SDK Does not implement this
		//
		self.getCPUUsage = function() {
		 	var dfd = $.Deferred();

		 	setTimeout(function(){
		 		var cpuUsage = 0;
		 		logger.info("CPU Interface: CPU Usage: " + cpuUsage + "%");
		    	dfd.resolve(cpuUsage);
		 	}, 100);

		 	return dfd;
		};

		//
		// Returns CPU Name.
		//
		self.getName = function() {
			var dfd = $.Deferred();

		 	setTimeout(function(){
		 		var cpuName = 'LG OnBoard';
		 		logger.info("CPU Interface: CPU Name: " + cpuName);
		    	dfd.resolve(cpuName);
		 	}, 100);

		 	return dfd;
		};

	}
	
	// The object is a singleton as there is only a single plugin added to the application
	return new CPUInterface();
});
