define(["system/io/FileInfo","system/io/Directory"], function(FileInfo, Directory) {
	function DirectoryInfo(path) {

		var self = this;
		self.path = path;

		self.directories = [];
		self.files = [];

		self.initialize = function() {
			var dfd = $.Deferred();
			new Storage().listFiles(
			 	// success
			 	function(result) {
			 		for (var i = 0; i < result.files.length - 1; i++) {
			 			var pathWithNoTrailingSlash = path.replace(/\/$/, "");
						var itemPath = pathWithNoTrailingSlash  + '/' + result.files[i].name;
			 			var file = new FileInfo(itemPath);
			 			file.type = result.files[i].type;
			 			self.files.push(file);
			 		}

			 		dfd.resolve();
			 	},
			 	// failed
			 	function(result) {
			 		logger.error('DirectoryInfo: Error whilst getting file list for: ' + path + '. Error: [' + result.errorCode + '] ' + result.errorText);
			 		dfd.reject();
			 	},
			 	{
			 		path: self.path 
			 	} // options
			);
			return dfd;
		};

		self.createSubDirectory = function(name) {
			var fullPath = self.path + "/" + name;
			return Directory.createDirectory(fullPath);
		};
	}

	return DirectoryInfo;
});
