define(["models/LocalFileList"], function(LocalFileList) {
    /**
     * A File Info class that also includes a method for deletion of the file
     * @param {[type]} path [description]
     */
    function FileInfo(path) {

        var self = this;
        self.path = path;
        self.name = '';
        self.type = 'file';

        // Get the filename
        if (self.path != null || self.path != undefined) {
            self.name = self.path.substring(self.path.lastIndexOf('/') + 1);
        }

        /**
         * Delete the file
         * @return {[type]} [description]
         */
        self.delete = function() {
            var dfd = $.Deferred();
            // Remove files using LG SDK removeFile method
            new Storage().removeFile(
                // Success
                function(result) {
                    logger.info('FileInfo: Successfully deleted file: ' + self.name + '.');
                    LocalFileList.remove(self.path).always(function() {
                        logger.info('Updated file list');
                        dfd.resolve(true);
                    });
                },
                // Failed
                function(result) {
                    logger.error('FileInfo: Error whilst deleting file: ' + self.name + '. Error: [' + result.errorCode + '] ' + result.errorText);
                    dfd.resolve(false);
                },
                // options
                {
                    file: self.path
                }
            );

            return dfd;
        };
    }

    return FileInfo;
});