define(function() {
	/*
		MemoryInterface provides access to low level Memory Information. The LG SDK Does not provide any methods
		that exposes any of this information so this will just return generic hard-coded values for now.
	 */
	function MemoryInterface() {

		var self = this;

		//
		//	Returns current RAM Usage (as a %). N/A in LG SDK so just returns a Hard-coded value
		//
		self.getRAMUsage = function() {

			var dfd = $.Deferred();
     
		    setTimeout(function() {
		    	var ramUsage = 0;
		    	logger.info("Memory Interface: Current RAM Usage: " + ramUsage + "%");
		    	dfd.resolve(ramUsage);
		    }, 100);

		    return dfd;
		};

		//
		//	Returns the total RAM available. Again N/A in the LG SDK so returns a Hard-coded value
		//
		self.getRAMTotalAvailable = function() {

			var dfd = $.Deferred();
     
		    setTimeout(function(){
		    	var totalRAMAvailable = 1024;
		    	logger.info("Memory Interface: Total RAM available: " + totalRAMAvailable);
		    	dfd.resolve(totalRAMAvailable);
		    }, 100);

		    return dfd;
		};

	}
	
	// The object is a singleton as there is only a single plugin added to the application
	return new MemoryInterface();
});
