define(function() {
	/*
		DEPRECATED - Should not be used.
		-------------------------------------------------------------
		This module has been replaced by a number of interface classes that provide more modular
		access to low level device/panel commands.

		The only reason this class hasn't just been removed all together is because it may come in handy
		when we eventually merge the SSSP code into this application.
	 */
	function LFDPlugin() {
		var self = this;

		// array of deferred requests that can be resolved/rejected when the method returns asyncronously
		var _deferredRequests = [];

		var sefMDCCommands = {
			GET_SERIAL_NUMBER : '0B',
			GET_MAINTENANCE_STATUS : '0D',
			GET_SOFTWARE_VERSION : '0E',
			VOLUME : '12',
			MUTE : '13',
			CONTRAST : '24',
			BRIGHTNESS : '25',
			REMOTE_CONTROL : '36',
			CONTRAST_RGB : '37',
			BRIGHTNESS_RGB : '38',
			SAFETY_LOCK : '5D',
			BUTTON_LOCK : '5F',
			SPEAKER_SELECT : '68',
			PANEL_ON_OFF_STATUS : 'F9'
		};

		self.getTemperature = function() {
			logger.debug('Get Temp');
			return sendMCDCommand(sefMDCCommands.GET_MAINTENANCE_STATUS, 1);
		};

		self.getVolume = function() {
			logger.debug('Get Volume');
			return sendMCDCommand(sefMDCCommands.VOLUME, 2);
		};

		self.getMuteStatus = function() {
			logger.debug('Get Mute Status');
			return sendMCDCommand(sefMDCCommands.MUTE, 3);
		};

		self.setMuteStatus = function(muteOn) {
			logger.debug('Set Mute Status');

			var data = (muteOn) ? ['01'] : ['00'];
			return sendMCDCommand(sefMDCCommands.MUTE, 15, data);
		};

		self.getContrast = function() {
			logger.debug('Get Contrast');
			return sendMCDCommand(sefMDCCommands.CONTRAST, 4);
		};

		self.getBrightness = function() {
			logger.debug('Get BRIGHTNESS');
			return sendMCDCommand(sefMDCCommands.BRIGHTNESS, 5);
		};

		self.getRemoteControlStatus = function() {
			logger.debug('Get Remote Control Status');
			return sendMCDCommand(sefMDCCommands.REMOTE_CONTROL, 6);
		};

		self.getContrastRGB = function() {
			logger.debug('Get Contrast RGB');
			return sendMCDCommand(sefMDCCommands.CONTRAST_RGB, 7);
		};

		self.getBrightnessRGB = function() {
			logger.debug('Get BRIGHTNESS RGB');
			return sendMCDCommand(sefMDCCommands.BRIGHTNESS_RGB, 8);
		};

		self.getSafetyLockStatus = function() {
			logger.debug('Get Safety Lock Status');
			return sendMCDCommand(sefMDCCommands.SAFETY_LOCK, 9);
		};

		self.getButtonLockStatus = function() {
			logger.debug('Get Button Lock Status');
			return sendMCDCommand(sefMDCCommands.BUTTON_LOCK, 10);
		};

		self.getSpeakerSelection = function() {
			logger.debug('Get Speaker Selection');
			return sendMCDCommand(sefMDCCommands.SPEAKER_SELECT, 11);
		};

		self.getScreenOnOffStatus = function() {
			logger.debug('Getting Screen On/Off Status');
			return sendMCDCommand(sefMDCCommands.PANEL_ON_OFF_STATUS, 12);
		};

		self.switchScreenOn = function() {
			logger.debug('Switching Screen On');
			return sendMCDCommand(sefMDCCommands.PANEL_ON_OFF_STATUS, 13, ['00']);
		};

		self.switchScreenOff = function() {
			logger.debug('Switching Screen Off');
			return sendMCDCommand(sefMDCCommands.PANEL_ON_OFF_STATUS, 14, ['01']);
		};

		self.switchOffSamsungOSD = function() {
			return null;
		};

		function sendMCDCommand(sefCommand, id, dataBufferToSend) {
			var dfd = $.Deferred();

			// create and store the deferred object
			_deferredRequests[id] = dfd;

			setTimeout(function() {
				dfd.resolve(0);
			}, 1000);

			return dfd;
		}


		self.reboot = function() {
			return null;
		};

		self.getCPUUsage = function() {
			var dfd = $.Deferred();

			// TODO: remove when the API is fixed
			setTimeout(function() {
				dfd.resolve(0);
			}, 1000);

			return dfd;
		};

		self.getSystemUpTime = function() {
			var dfd = $.Deferred();
			try {
				logger.debug('Get System Uptime');

				var plugin = document.getElementById('sefUptimePlugin');
				plugin.OnEvent = function(event, p1, p2) {
					logger.debug('Uptime ' + event + ' Seconds' + ' P1: ' + p1 + ' P2: ' + p2);
					//plugin.Close();

					if (p1 != null && p1 != undefined && p1.length > 0) {
						pluginEventHandler(event, p1, p2);
					} else {
						dfd.resolve(event);
					}
				};
				plugin.Open("LFD", "1.000", "LFD");
				plugin.Execute("getSystemUpTime", "getSystemUpTime");

			} catch(e) {
				logger.error('Could not get System Uptime ' + e.message);
				dfd.reject();
			}

			return dfd;
		};

		self.getRAMUsage = function() {
			var dfd = $.Deferred();

			return dfd;
		};
		/*** END NEW LFD API Methods ***/

	}

	// The object is a singleton as there is only a single plugin added to the application
	return new LFDPlugin();
});
