define(function() {
	function TVInPlugin(x, y, width, height) {
		var self = this;

		var _muted = true;
		var _isPlaying = false;

		// need to scale the Media Window as its resolution is 960x540!
		var xScalar = 960 / document.documentElement.clientWidth;
		var yScalar = 540 / document.documentElement.clientHeight;

		self.x = x * xScalar;
		self.y = y * yScalar;
		self.width = width * xScalar;
		self.height = height * yScalar;

		// the Window appears to work with the co-ordinate system of 960x540

		self.windowPlugin = document.getElementById("windowPlugin");
		self.tvmwPlugin = document.getElementById("TVMWplugin");
		self.audioPlugin = document.getElementById("audioPlugin");

		self.showTVIn = function() {
			try {
				// get the original source (so it can be set back when complete)
				self.originalSource = self.tvmwPlugin.GetSource();

				// need to scale the Media Window as its resolution is 960x540!
				var xScalar = 960 / document.documentElement.clientWidth;
				var yScalar = 540 / document.documentElement.clientHeight;

				self.windowPlugin.SetScreenRect(self.x, self.y, self.width, self.height);
				//31 - HDMI
				self.tvmwPlugin.SetSource(31);
				
				self.setMute(_muted);

				_isPlaying = true;
			} catch(e) {
				logger.error('Error setting TV In Source ' + e.message);
			}
		};

		self.stop = function() {
			try {
				_isPlaying = false;
				
			} catch(e) {
				logger.error('Error whilst stopping TV IN Plugin ' + e.message);
			}
		};

		self.setMute = function(muted) {
			_muted = muted;

			//TODO:do properly
			return;

			// mute/unmute the video
			var muteState = (_muted) ? 1 : 0;
			self.audioPlugin.SetUserMute(muteState);

		};

		self.volumeUp = function() {
			if (_isPlaying) {
				self.setMute(false);
				self.audioPlugin.SetVolumeWithKey(0);
			}
		};

		self.volumeDown = function() {
			if (_isPlaying) {
				self.setMute(false);
				self.audioPlugin.SetVolumeWithKey(1);
			}
		};
	}

	return TVInPlugin;
});
