define([], function() {
	
	/**
	 * Luna API Interface
	 * ---------------------------------
	 * Allows LG client to send messages using the Luna API
	 */
	function LunaAPIInterface() {

		var self = this;
		
		/**
		 * Allows us to call the WebOS Luna API
		 * @param  {[type]}   url      The URL of the method
		 * @param  {[type]}   params   Stringified JSON Object with method params
		 * @param  {Function} callback The callback - returns a JSON object representing the reponse
		 * @return {[type]}            [description]
		 */
		self.call = function(url, params, callback)
		{
			try
			{
				// Create new Palm Bridge
				var bridge = new PalmServiceBridge();
				bridge.url = url;
				bridge.onservicecallback = function(response) {
					callback(JSON.parse(response));
				};
				return bridge.call(url, params);

			}
			catch (e)
			{
				logger.error("LunaAPIInterface: Error trying to call luna service " + e);
			}
		};

	}
	
	// The object is a singleton as there is only a single inteface added to the application
	return new LunaAPIInterface();
});