define(function() {
	/*
		TemperatureInterface provides access to low level Temperature Information
	 */
	function TemperatureInterface() {

		var self = this;

		//
		//	Returns System Temp. LG SDK Does not provide this so just return some hard-coded value for now
		//
		self.getTemperature = function() {

			var dfd = $.Deferred();
     
		    setTimeout(function() {
		    	var temperature = 0;
		    	logger.info("Temperature Interface: Temperature: " + temperature);
		    	dfd.resolve(temperature);
		    }, 100);

		    return dfd;
		};


		//
		//	Returns System Temp Unit. LG SDK Does not provide this so just return some hard-coded value for now
		//
		self.getTemperatureUnit = function() {

			var dfd = $.Deferred();
     
		    setTimeout(function() {
		    	var temperatureUnit = "celsius";
		    	logger.info("Temperature Interface: Temperature Unit: " + temperatureUnit);
		    	dfd.resolve(temperatureUnit);
		    }, 100);

		    return dfd;
		};

		//
		//	Returns System Sensor Name. LG SDK Does not provide this so just return some hard-coded value for now
		//
		self.getSensorName = function() {

			var dfd = $.Deferred();
     
		    setTimeout(function(){
		    	var sensorName = "Screen";
		    	logger.info("Temperature Interface: Sensor Name: " + sensorName);
		    	dfd.resolve(sensorName);
		    }, 100);

		    return dfd;
		};

	}
	
	// The object is a singleton as there is only a single plugin added to the application
	return new TemperatureInterface();
});