define(["system/DateTime"], function(DateTime) {
    var logger = {
        levels: {
            DEBUG: 0,
            INFO: 1,
            WARNING: 2,
            ERROR: 3,
            FATAL: 4
        },
        level: 0,
        enableTrace: false,
        traceCounter: 0,
        traceCounterMax: 18,
        debug: function(msg) {
            //if (this.enableTrace) {
            if (this.level == this.levels.DEBUG) {
                msg = DateTime.now().toLocaleString() + " DEBUG   " + msg;
                this.trace(msg);

                console.log(msg);
            }
            //}
        },
        info: function(msg) {
            //if (this.enableTrace) {
            if (this.level <= this.levels.INFO) {
                msg = DateTime.now().toLocaleString() + " INFO    " + msg;
                this.trace(msg);

                console.info(msg);
            }
            //}
        },
        warning: function(msg) {
            //if (this.enableTrace) {
            if (this.level <= this.levels.WARNING) {
                msg = DateTime.now().toLocaleString() + " WARNING " + msg;
                this.trace(msg);

                console.warn(msg);
            }
            //}
        },
        error: function(msg) {
            //if (this.enableTrace) {
            if (this.level <= this.levels.ERROR) {
                msg = DateTime.now().toLocaleString() + " ERROR   " + msg;
                this.trace(msg);

                console.error(msg);
            }
            //}
        },
        fatal: function(msg) {
            //if (this.enableTrace) {
            if (this.level <= this.levels.FATAL) {
                msg = DateTime.now().toLocaleString() + " FATAL   " + msg;
                this.trace(msg);

                console.error(msg);
            }
            //}
        },
        trace: function(msg) {
            if (this.enableTrace) {

                if (this.traceCounter == this.traceCounterMax) {
                    $('#trace span:first').remove();
                    this.traceCounter = (this.traceCounterMax - 1);
                }
                $('#trace').append('<span>' + msg + '<br/></span>');
                this.traceCounter++;
            }
        }
    };

    window.logger = logger;

    return logger;
});